
-- Deutz D06
-- Specialization for Deutz D06 mod
-- Date 04/09/2015
-- Copyright(C) Puma Forbidden-Mods


DeutzD06 = {};

function DeutzD06.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function DeutzD06:load(savegame)
    self.frontLinkageBottomArmRotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.frontBottomArm#visNode"));
    setVisibility(self.frontLinkageBottomArmRotNode, false) ;
end;

function DeutzD06:delete()
end;

function DeutzD06:readStream(streamId, connection)
end;

function DeutzD06:writeStream(streamId, connection)
end;

function DeutzD06:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DeutzD06:keyEvent(unicode, sym, modifier, isDown)
end;

function DeutzD06:update(dt)
end;

function DeutzD06:updateTick(dt)
end;

function DeutzD06:draw()
end;

function DeutzD06:onLeave()
end;

function DeutzD06:onEnter()
end;

function DeutzD06:attachImplement(implement)
    local jointType = implement.object.attacherJoint.jointType;
    local jointIndex = implement.jointDescIndex;

    if jointType == Vehicle.JOINTTYPE_IMPLEMENT then
        if implement.object.needsLowering then
            self.implementCount = math.max(self.implementCount - 1, 0);
        end;
        if jointIndex == 2 then
            setVisibility(self.frontLinkageBottomArmRotNode, true);
        end;
    elseif jointType == Vehicle.JOINTTYPE_TRAILER then
        if jointIndex == 3 then
        end;
    elseif jointType == Vehicle.JOINTTYPE_TRAILERLOW then
        if jointIndex == 4 then
        end;
    end;

    self.updateJoint = true;
end;

function DeutzD06:detachImplement(implementIndex)
    local implement = self.attachedImplements[implementIndex];
    local jointIndex = implement.jointDescIndex;

    if implement.object.attacherJoint.jointType == Vehicle.JOINTTYPE_IMPLEMENT then
        if implement.object.needsLowering then
            self.implementCount = self.implementCount + 1;
        end;
        if jointIndex == 2 then
            setVisibility(self.frontLinkageBottomArmRotNode, false);
        end;
    else
    end;

    self.updateJoint = true;
end;

function DeutzD06:validateAttacherJoint(implement, jointDesc, dt)
    if self.updateJoint then
        self.updateJoint = false;
        return true;
    end;
    return false;
end;
